/* VERSION 21-11-1998 */

#include "stdio.h"
#include "dos.h"
#include "bios.h"
#include "stdlib.h"
#include "alloc.h"
#include "time.h"

void mode(int mode_code);
void locate(int x,int y);
void cls();
int dmode(void);
void velocidad(void);
void espera(unsigned int c);
void sonido(unsigned int frecuencia,unsigned int duracion);
void mouse(int x);
void bar(unsigned char ca,int x,int y,int ancho,int alto);
void box(int x,int y,int ancho,int alto);
void print(unsigned char tinta,unsigned char papel,unsigned char cara,unsigned char repe);
void impri(int x,int y,unsigned char c);
void getblock(int n,int x,int y,unsigned char ancho,unsigned char alto);
void putblock(int n,int x,int y);
void cursoroff(void);
void cursoron(void);
/* -------------------------------- */
/* ---- RUTINAS NORMALES ----- */
void inputc(int x,int y,char *texto);
long inputn(int x,int y,char *texto);
unsigned int inkey2(void);
int inkey(void);
void mks( long num);
void printc(int x,int y,char *texto);
void printn(int x,int y,long num);
void error(int z);
void waits(unsigned int x);
/* --------------------------- */


int INK=7,PAPER=0,SPEED,XMOUSE,YMOUSE,KMOUSE,CMOUSE,MX,MY,MK;
int FONTX=1,FONTY=1;
FILE *pf;

char VARI[160];

unsigned char far *pvx;
unsigned char far *pvm;
unsigned char far *pv,*pv1;
unsigned char far *grafi[16];

/* ---- TRANSFORMA NUMERO A CADENA ----*/
void mks( long num)
{
 int z;
 for(z=0;z<40;z++)VARI[z]=0;
 sprintf(VARI,"%lu",num);
}
/* ------BORRA EL CURSOR----- */
void cursoroff(void)
{
union REGS r;
r.h.ah=1;
r.h.cl=0;
r.h.ch=0x20;
int86(0x10,&r,&r);
}
/* ------HACE APARECER EL CURSOR----- */
void cursoron(void)
{
union REGS r;
r.h.ah=1;
r.h.cl=0x07;
r.h.ch=0x06;
int86(0x10,&r,&r);
}

/* ---- LEE CADENA DEL TECLADO ----*/
void inputc(int x,int y,char *texto)
{
int z,zz,n;
	printc(x,y,texto);
	for(z=0;z<40&&texto[z]!=0;z++);
	x=x+z;	z=x; n=0; zz=0;
	locate(x,y);
	while(zz!=13)
		{
		 zz=inkey();
		 if(zz==13 || zz==27) goto fin;
		 if(zz!=0)
			{
			 if(zz==8)
				{
				 if(n!=0){z--;n--;impri(z,y,32);}
				}
				else
				{
				 impri(z,y,zz);
				 if(n<38){z++; VARI[n]=zz; n++; locate(z,y);}
				}
			}
		}
fin:
	VARI[n]=0;

}

/* ---- LEE NUMERO DEL TECLADO ----*/
long inputn(int x,int y,char *texto)
{
	inputc(x,y,texto);
	return(atol(VARI));
}

/* ----    LEE TECLA   ---*/
int inkey(void)
{
 int t;
 do
  { if(bioskey(1)!=0){t=bioskey(0);} else {t=0;}
   }
 while(bioskey(1)!=0);
 return(t&255);
 }

/* ----    LEE TECLA COMPLETA   ---*/
unsigned int inkey2(void)
{
 int t;
 do
  { if(bioskey(1)!=0){t=bioskey(0);} else {t=0;}
   }
 while(bioskey(1)!=0);
 return(t);
 }

/* tinta-papel-caracter-repeticion */
void print(unsigned char tinta,unsigned char papel,unsigned char cara,unsigned char repe)
{
union REGS r;
r.h.ah=9;
r.h.al=cara;
r.h.bh=0;
r.h.bl=tinta+papel*16;
r.x.cx=repe;
int86(0x10,&r,&r);
}

/* modo de pantalla */
void mode(int mode_code)
{
union REGS r;
r.h.al=mode_code;
r.h.ah=0;
int86(0x10,&r,&r);
}
/* colocar cursor en un lugar determinado */
void locate(int x,int y)
{
union REGS r;
r.h.ah=2;
r.h.dl=x;
r.h.dh=y;
r.h.bh=0;
int86(0x10,&r,&r);
}
/*borra pantalla*/
void cls()
{
union REGS r;
r.h.ah=6;
r.h.al=0;
r.h.ch=0;
r.h.cl=0;
r.h.dh=24;
r.h.dl=79;
r.h.bh=7;
int86(0x10,&r,&r);
}
/* da modo de pantalla */
int dmode(void)
{
union REGS r;
r.h.al=0;
r.h.ah=0x0F;
int86(0x10,&r,&r);
return(r.h.al);
}

/*---- devuelve la velocidad del ordenador ----*/
void velocidad(void)
{
unsigned int c,cc,z;
union REGS r;
r.h.ah=0;
int86(0x1A,&r,&r);
c=r.x.dx;
for(cc=0;cc<40000;cc++)for(z=0;z<33;z++);
r.h.ah=0;
int86(0x1A,&r,&r);
cc=r.x.dx;cc=cc-c;cc=2000/cc;SPEED=cc/10;
}
/*--- espera un tiempo  calculado 18 cada segundo---*/
void espera(unsigned int c)
{
unsigned int cc;
union REGS r;
r.h.ah=0;
int86(0x1A,&r,&r);
cc=r.x.dx;
cc+=c;
c=0;
while(c<cc){r.h.ah=0;int86(0x1A,&r,&r);c=r.x.dx;}
}
/* --- produce un sonido --*/
void sonido(unsigned int frecuencia,unsigned int duracion)
{
	unsigned char c;
	unsigned int x;
	frecuencia=frecuencia*SPEED;
	disable();
	c=inportb(0x61);
	c=c&0xFE;
while(duracion>1)
	{
	c=c|0x02;
	outportb(0x61,c);
	x=frecuencia;
	while(x>1)x--;
	c=c&0xFD;
	outportb(0x61,c);
	x=frecuencia;
	while(x>1)x--;
	duracion--;
	}
enable();
}

/* ------MOUSE ------ */
/* 0-borra cursor   1-mouse visible   2-oculta mouse   3-carga datos */
void mouse(int x)
{
  union REGS r;

  switch(x)
	{
	case 0: r.x.ax=0x0000;
		int86(0x33,&r,&r);
		break;
	case 1: r.x.ax=0x0001;
		int86(0x33,&r,&r);
		break;
	case 2: r.x.ax=0x0002;
		int86(0x33,&r,&r);
		break;
	case 3: r.x.ax=0x0003;
		int86(0x33,&r,&r);
		XMOUSE=r.x.cx;
		YMOUSE=r.x.dx;
		KMOUSE=r.x.bx;
		CMOUSE=0;
		if(MX!=XMOUSE || MY!=YMOUSE || MK!=KMOUSE) CMOUSE=1;
		MX=XMOUSE; MY=YMOUSE;
		break;
	default: ;

	}
}

/* ------espera x segundos-------*/
void waits(unsigned int x)
{
 unsigned int ti,z;

 ti=time(NULL) ; z=ti; ti+=x ; while(ti-z>1) z=time(NULL);
}

void box(int x,int y,int ancho,int alto)
{
 int z;
 locate(x,y);print(INK,PAPER,196,ancho);
 locate(x,y+alto);print(INK,PAPER,196,ancho);
 for(z=y;z<y+alto;z++)
				{
				 locate(x,z);print(INK,PAPER,179,1);
				 locate(x+ancho,z);print(INK,PAPER,179,1);
				}
  locate(x,y);print(INK,PAPER,218,1);
  locate(x+ancho,y);print(INK,PAPER,191,1);
  locate(x,y+alto);print(INK,PAPER,192,1);
  locate(x+ancho,y+alto);print(INK,PAPER,217,1);
}

void bar(unsigned char ca,int x,int y,int ancho,int alto)
{
 int z;
 for(z=y;z<y+alto;z++)
				{
				 locate(x,z);print(INK,PAPER,ca,ancho);
				}
}

/* ----IMPRIME CARACTER ---*/
void impri(int x,int y,unsigned char c)
{
 locate(x,y);
 print(INK,PAPER,c,1);
}

/* ----IMPRIME CADENA ---*/
void printc(int x,int y,char *texto)
{
 unsigned char z;
 for(z=0;z<80 && texto[z]!=0;z++){
		impri(x,y,texto[z]);
		x+=1;
		}
}
/* ---- IMPRIME NUMERO ----*/
void printn(int x,int y,long num)
{
 mks(num);
 printc(x,y,VARI);
}
void getblock(int n,int x,int y,unsigned char ancho,unsigned char alto)
{
	unsigned int c,cc;
	unsigned char *base;

	ancho=ancho*2+1;
	c=ancho*alto+2;
	if(grafi[n]!=0) free(grafi[n]);
	grafi[n]=malloc(c);
	if(grafi[n]==0){printc(0,0,"sin memoria"); goto getfin;}
	base=grafi[n];
	*base=ancho; base++;
	*base=alto;  base++;
	c=y*80+x;
	pv=pvx+c;
	for(cc=1;cc<alto;cc++)
		{
		for(c=1;c<ancho;c++)
			{
			 *base=*pv;
			 base++;
			 pv++;
			}
		pv=pv-ancho+81;
		if(pv>pvm)pv=pvm;
		}
 getfin:
 c++;
}

void putblock(int n,int x,int y)
{
	unsigned int c,cc;
	unsigned char *base;
	unsigned char ancho,alto;

	base=grafi[n];
	if(base==0) goto putfin;
	ancho=*base;
	base++;
	alto=*base;
	base++;
	c=y*80+x;
	pv=pvx+c;
	for(cc=1;cc<alto;cc++)
		{
		for(c=1;c<ancho;c++)
			{
			if(x+c<=80) *pv=*base;
			 base++;
			 pv++;
			 if(pv>pvm)pv=pvm;
			}
		pv=pv-ancho+81;
		if(pv>pvm)pv=pvm;
		}



 putfin:
 c++;
}
/* ------ Tratamiento de errores ----- */
void error(int z)
{
int m;
	m=dmode();
	mode(2);
	locate(0,0);
	switch(z)
		{
		 case 2:
			printf("Fichero no encontrado");
			break;
		 case 8:
			printf("Memoria insuficiente");
			break;
		 case 13:
			printf("Dato invalido");
			break;
		 default:
			printf("Error desconocido");
			break;
		}
	while(inkey()==0);
	mode(m);
}